#
# spec file for package hdjmod
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
# Copyright (c) 2008-2017 Matthias Bach <marix@marix.org>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           hdjmod
Version:        1.28
Release:        lp152.6.2.1
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?suse_version} < 1120
BuildRequires:  %kernel_module_package_buildreq
BuildRequires:  module-init-tools
%else
BuildRequires:  %kernel_module_package_buildreqs
%endif
BuildRequires:  libelf-devel
Summary:        Support for Hercules DJ Devices
License:        GPL-2.0-or-later
Group:          System/Kernel
Url:            http://ts.hercules.com/ger/index.php?pg=view_files&gid=17&fid=62&pid=177&cid=1
Source0:        hdjmod-%{version}.tar.bz2
Source1:        preamble
# PATCH-FIX-UPSTREAM hdjmod_kernel_2.6.30.patch marix@marix.org -- Fix build on kernel 2.6.30 and newer
Patch0:         hdjmod_kernel_2.6.30.patch
# PATCH-FIX-UPSTREAM hdjmod_kernel_2.6.36.patch marix@marix.org -- Fix includes for kfree
Patch1:         hdjmod-kfree.patch
# PATCH-FIX-UPSTREAM hdjmod_kernel_2.6.36.patch marix@marix.org -- Fix build on kernel 2.6.36 and newer
Patch2:         hdjmod_kernel_2.6.36.patch.bz2
# PATCH-FIX-UPSTREAM hdjmod_kernel_2.6.37.patch marix@marix.org -- Fix build on kernel 2.6.37 and newer
Patch3:         hdjmod_kernel_2.6.37.patch
# PATCH-FIX-UPSTREAM hdjmod_kernel_2.6.39.patch marix@marix.org -- Fix build on kernel 2.6.39 and newer
Patch4:         hdjmod_kernel_2.6.39.patch
# PATCH-FIX-UPSTREAM hdjmod_fix_hotplug.patch [bnc#746358] marix@marix.org -- Don't load on hotplug of devices from other vendors
Patch5:         hdjmod_fix_hotplug.patch
# PATCH-FIX-UPSTREAM hdjmod_kernel_3.6.patch [bnc#783848] marix@marix.org -- Fix build on kernel 3.6 and newer
Patch6:         hdjmod_kernel_3.6.patch
# PATCH-FIX-UPSTREAM hdjmod_kernel_3.7.patch marix@marix.org -- Fix build on kernel 3.7 and newer
Patch7:         hdjmod_kernel_3.7.patch
# PATCH-FIX-UPSTREAM hdjmod_kernel_3.16.patch marix@marix.org -- Fix build on kernel 3.16 and newer
Patch8:         hdjmod_kernel_3.16.patch
# PATCH-FIX-UPSTREAM hdjmod_kernel_4.11.patch marix@marix.org -- Fix build on kernel 4.11 and newer
Patch9:         hdjmod_kernel_4.11.patch
# PATCH-FIX-UPSTREAM hdjmod_fix_buffer_overrun_in_device_name_handling.patch marix@marix.org -- Fix build on kernel 4.11 and newer
Patch10:        hdjmod_fix_buffer_overrun_in_device_name_handling.patch
# PATCH-FIX-UPSTREAM hdjmod_kernel_4.14.patch marix@marix.org -- Fix build on kernel 4.14 and newer
Patch11:        hdjmod_kernel_4.14.patch
# PATCH-FIX-UPSTREAM hdjmod_kernel_4.15.patch marix@marix.org -- Fix build on kernel 4.15 and newer
Patch12:        hdjmod_kernel_4.15.patch
# Fix build with kernel 5.0
Patch13:        hdjmod_kernel_5.0.patch

%suse_kernel_module_package -p%_sourcedir/preamble

%description
This is the Hercules DJ Series Kernel Module, which supports Hercules DJ Devices.

%prep
echo %flavors_to_build
%setup -q
%if 0%{?suse_version} >= 1120 || 0%{?sles_version} > 10
%patch0 -p1
%endif
%if 0%{?suse_version} >= 1140 || 0%{?sles_version} > 10
%patch2 -p1
%patch3 -F3 -p1
%patch4 -p1
%endif
%patch1 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p2
set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
for flavor in %flavors_to_build; do
        rm -rf obj/$flavor
        cp -r source obj/$flavor
        make -C %{kernel_source $flavor} %{?linux_make_arch} modules M=$PWD/obj/$flavor
done

%install
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
        make -C %{kernel_source $flavor} %{?linux_make_arch} modules_install M=$PWD/obj/$flavor
done

%changelog
* Mon Mar 18 2019 Michal Suchanek <msuchanek@suse.com>
- Fix build with kernel 5.0:
  * hdjmod_kernel_5.0.patch
* Tue Jun 19 2018 msuchanek@suse.com
- Use %%{?linux_make_arch} when building kernel modules (boo#1098050).
* Sat Feb 10 2018 marix@marix.org
- Added hdjmod_kernel_4.15.patch: Fixes build on Kernel 4.15 and
  up.
- Removed accidentally added backup file from
  hdjmod_fix_hotplug.patch
* Sun Nov 26 2017 marix@marix.org
- Added hdjmod_kernel_4.14.patch: Fixes build on Kernel 4.14 and
  up.
* Sat Jul  1 2017 marix@marix.org
- Added hdjmod_fix_buffer_overrun_in_device_name_handling.patch:
  Fixes a potential buffer overrun in device name handling.
* Fri May 26 2017 marix@marix.org
- Added hdjmod_kernel_4.11.patch: Fixes build on Kernel 4.11 and
  up.
* Fri Jul 25 2014 marix@marix.org
- Fixed build on kernel 3.16
  The required patch is hdjmod_kernel_3.16.patch
* Sun Dec 23 2012 marix@marix.org
- Fixed build on kernel 3.7
* Tue Oct 16 2012 marix@marix.org
- Fixed build on kernel 3.6
* Sat Apr  7 2012 marix@marix.org
- Fixed build on SLE 11 SP 2
* Tue Mar 13 2012 marix@marix.org
- Fixed USB hotplugging
  Previously the module also loaded for devices of other vendors.
* Wed Aug  3 2011 cfarrell@novell.com
- license update: GPL-2.0+
  Specify the license more accurately using the appropriate syntax
* Mon May 30 2011 marix@marix.org
- Fixed build on kernels newer than openSUSE 11.4
* Sat Apr 30 2011 marix@marix.org
- Fixed build on SLE 11 SP 1
* Sat Apr 30 2011 marix@marix.org
- Cleaned up spec file
- Fixed missing dependency to the kernel
* Thu Dec  2 2010 marix@marix.org
- Patched to fix build with kernel 2.6.37
* Sun Sep 26 2010 marix@marix.org
- Patched to fix build with kernels newer than openSUSE 11.3
* Sun Jul 25 2010 marix@marix.org
- Build for older openSUSE versions
* Sun Jul 25 2010 marix@marix.org
- Initial version
